#include-once

;===============================================================================
;
; Function Name:   _GetVolumeID
; Description::    Receives the Volume ID of the given Volume
; Parameter(s):     $sHD: The Volume path (e.g. C:)
;			$iRetMode: The Return Mode   0=with - (e.g. 1234-1234) all else (e.g. 1) = without - (e.g. 12341234)
; Requirement(s):  cmd.exe
; Return Value(s): Volume ID on succes
;			Return 0 and @error = 1 on faild
; Author:       GtaSpider
;
;===============================================================================

Func _GetVolumeID($sHD = "C:",$iRetMode = 0)
	Local $pid
	$pid = Run(@ComSpec & ' /c dir '&$sHD, '', @SW_HIDE,6)
	While ProcessExists($pid)
		Sleep(50)
	WEnd
	If StderrRead($pid) <> "" Then Return SetError(1,0,0)
	$readout = StdoutRead($pid)
	$readout = StringTrimLeft($readout,StringInStr($readout,"Volumeseriennummer: ")+19)
	$readout = StringLeft($readout,9)
	If $iRetMode = 0 Then
		Return $readout
	Else
		Return StringReplace($readout,"-","")
	EndIf
EndFunc

;===============================================================================
; 
; WARNING!!! Save you volume ID bevor you will change it, cause many programms need this ID (e.g. ICQ for pw's) WARNING!!!
;
; Function Name:   _SetVolumeID
; Description::    Set the Volume ID of the given Volume
; Parameter(s):     $sHD: The Volume path (e.g. C:)
;			$iID: The Volume ID to set (e.g. 1234-1234 or 12341234)
; Requirement(s):  Volumeid.exe (in ZIP)
; Return Value(s):  Return 1 on succes
;			Return 0 and @error = 1 on faild 
; Author:       GtaSpider
;
; Note:           new NTFS volume ids will not appear in directory listings until after the next reboot.
;
;===============================================================================

Func _SetVolumeID($sHD,$iID)
	Local $pid
	If Not StringInStr($iID,"-") Then $iID = StringLeft($iID,4)&"-"&StringRight($iID,4)
	$pid  = Run("Volumeid.exe "&$sHD&" "&$iID,"",@SW_HIDE,6)
	While ProcessExists($pid)
		Sleep(50)
	WEnd
	If StringInStr(StdoutRead($pid),"xxxx-xxxx") Then Return SetError(1,0,0)
	Return 1
EndFunc
	
	